Unit fta3e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTA1P_p;

procedure fta3e(var ARRAY_ :Array of Extended; var N :Integer;
                IREG :Integer);

implementation

procedure fta3e(var ARRAY_ :Array of Extended; var N :Integer;
                IREG :Integer);
var
N2P3,N21,I,I1,I2,I3,I4 :Integer;
C1,C2,WRS,WIS,H1R,H1I,H2R,H2I,WR,WI,WPR,WPI,WTEMP,THETA :Extended;
const
SYS003 :Extended = 6.2831853071795864769252867665590;
TWO :Extended = 2.0e0;
HALF :Extended = 0.5e0;
ONE :Extended = 1.0e0;
label
_10,_20,_30,_40,_50;
begin
THETA := SYS003/TWO/(N);
C1 := HALF;
if ( IREG = 1 ) 
 then goto _10;
C2 := HALF;
THETA := -THETA;
goto _20;
_10:
C2 := -HALF;
FTA1P(ARRAY_,N,1);
_20:
WPR := -TWO*IntPower(Sin(HALF*THETA),2);
WPI := Sin(THETA);
WR := ONE+WPR;
WI := WPI;
N2P3 := Trunc( 2*N+3 );
N21 := Trunc( N/2+1 );
for I:=2 to N21 do
 begin
  I1 := Trunc( 2*I-1 );
  I2 := I1+1;
  I3 := N2P3-I2;
  I4 := I3+1;
  WRS := WR;
  WIS := WI;
  H1R := C1*(ARRAY_[I1-1]+ARRAY_[I3-1]);
  H1I := C1*(ARRAY_[I2-1]-ARRAY_[I4-1]);
  H2R := -C2*(ARRAY_[I2-1]+ARRAY_[I4-1]);
  H2I := C2*(ARRAY_[I1-1]-ARRAY_[I3-1]);
  ARRAY_[I1-1] := H1R+WRS*H2R-WIS*H2I;
  ARRAY_[I2-1] := H1I+WRS*H2I+WIS*H2R;
  ARRAY_[I3-1] := H1R-WRS*H2R+WIS*H2I;
  ARRAY_[I4-1] := -H1I+WRS*H2I+WIS*H2R;
  WTEMP := WR;
  WR := WR*WPR-WI*WPI+WR;
  WI := WI*WPR+WTEMP*WPI+WI;
_30:
 end;
if ( IREG = 1 ) 
 then goto _40;
H1R := ARRAY_[0];
ARRAY_[0] := C1*(H1R+ARRAY_[1]);
ARRAY_[1] := C1*(H1R-ARRAY_[1]);
FTA1P(ARRAY_,N,-1);
goto _50;
_40:
H1R := ARRAY_[0];
ARRAY_[0] := H1R+ARRAY_[1];
ARRAY_[1] := H1R-ARRAY_[1];
_50:
end;

end.
