Unit fta5e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTA3E_p;

procedure fta5e(var ARRAY_ :Array of Extended; N :Integer; IREG :Integer); 

implementation

procedure fta5e(var ARRAY_ :Array of Extended; N :Integer;
                IREG :Integer);
var
M,J,M1,NJ1,N1 :Integer;
SUM,Y1,Y2,EVEN,ODD,ENF,SUME,WR,WI,WPR,WPI,WTEMP,THETA :Extended;
const
SYS001 :Extended = 3.1415926535897932384626433832795;
ONE :Extended = 1.0e0;
ZERO :Extended = 0.0e0;
TWO :Extended = 2.0e0;
HALF :Extended = 0.5e0;
H :Extended = 0.5e0;
T :Extended = 2.0e0;
label
_10,_20,_30,_40,_45,_50;
begin
THETA := SYS001/(N);
WR := ONE;
WI := ZERO;
WPR := -TWO*IntPower(Sin(HALF*THETA),2);
WPI := Sin(THETA);
SUM := ARRAY_[0];
M := Trunc( N/2 );
M1 := M-1;
for J:=1 to M1 do
 begin
  WTEMP := WR;
  WR := WR*WPR-WI*WPI+WR;
  WI := WI*WPR+WTEMP*WPI+WI;
  NJ1 := N-J+1;
  Y1 := H*(ARRAY_[J+0]+ARRAY_[NJ1-1]);
  Y2 := (ARRAY_[J+0]-ARRAY_[NJ1-1]);
  ARRAY_[J+0] := Y1-WI*Y2;
  ARRAY_[NJ1-1] := Y1+WI*Y2;
  SUM := SUM+WR*Y2;
_10:
 end;
FTA3E(ARRAY_,M,1);
ARRAY_[1] := SUM;
J := 4;
while ( J<=N ) do
 begin
  SUM := SUM+ARRAY_[J-1];
  ARRAY_[J-1] := SUM;
_20:
  inc(J,2);
 end;
if ( IREG = 1 ) 
 then goto _50;
EVEN := ARRAY_[0];
ODD := ARRAY_[1];
N1 := N-1;
J := 3;
while ( J<=N1 ) do
 begin
  EVEN := EVEN+ARRAY_[J-1];
  ODD := ODD+ARRAY_[J+0];
_30:
  inc(J,2);
 end;
ENF := T*(EVEN-ODD);
SUM := ARRAY_[0]-ENF;
SUME := (T*ODD/(N))-SUM;
ARRAY_[0] := H*ENF;
ARRAY_[1] := ARRAY_[1]-SUME;
J := 3;
while ( J<=N1 ) do
 begin
  ARRAY_[J-1] := ARRAY_[J-1]-SUM;
  ARRAY_[J+0] := ARRAY_[J+0]-SUME;
_40:
  inc(J,2);
 end;
Y1 := T/(N);
for J:=1 to N do
 begin
  ARRAY_[J-1] := Y1*ARRAY_[J-1];
_45:
 end;
_50:
end;

end.
